//+------------------------------------------------------------------+
//|                                                         
string VersionNumber = "5_34_5_EA_v1_0";
//
//+------------------------------------------------------------------+


#property copyright ""
#property link      ""

//---- input parameters
extern double  Lots = 0.1;
extern int     Slippage = 4;
extern int     MaximumOpenTrades = 3;
extern bool    OkToTrade = true;

extern bool    PopUpAlert = true;
extern int     NumberOfTries = 5;
extern int     SleepTime =  1000; //time in milli secs
extern int     MagicBase = 10;


double TrendBuffer;
double LoBuffer;

double ChartProfit;
double Spread,WorstSpread;

int   MagicNo, LastTrend;
int   SellOpenOrders, BuyOpenOrders;
int   TickRotate = 0;
int   BarCount;
int   CurrentDayOfYear;

string _text1, _text2, _text3 ,  DisplayText, TickDisplay, CrLf = "\n";


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   BarCount = Bars;
   CurrentDayOfYear = DayOfYear();

   // Set the Magic number
   if( Symbol() == "AUDCADm" || Symbol() == "AUDCAD" ) { MagicNo = 9010 * MagicBase; }
   if( Symbol() == "AUDJPYm" || Symbol() == "AUDJPY" ) { MagicNo = 9020 * MagicBase; }
   if( Symbol() == "AUDNZDm" || Symbol() == "AUDNZD" ) { MagicNo = 9030 * MagicBase; }
   if( Symbol() == "AUDUSDm" || Symbol() == "AUDUSD" ) { MagicNo = 9040 * MagicBase; }
   if( Symbol() == "CHFJPYm" || Symbol() == "CHFJPY" ) { MagicNo = 9050 * MagicBase; }
   if( Symbol() == "EURAUDm" || Symbol() == "EURAUD" ) { MagicNo = 9060 * MagicBase; }
   if( Symbol() == "EURCADm" || Symbol() == "EURCAD" ) { MagicNo = 9070 * MagicBase; }
   if( Symbol() == "EURCHFm" || Symbol() == "EURCHF" ) { MagicNo = 9080 * MagicBase; }
   if( Symbol() == "EURGBPm" || Symbol() == "EURGBP" ) { MagicNo = 9090 * MagicBase; }
   if( Symbol() == "EURJPYm" || Symbol() == "EURJPY" ) { MagicNo = 9100 * MagicBase; }
   if( Symbol() == "EURUSDm" || Symbol() == "EURUSD" ) { MagicNo = 9110 * MagicBase; }
   if( Symbol() == "GBPCHFm" || Symbol() == "GBPCHF" ) { MagicNo = 9120 * MagicBase; }
   if( Symbol() == "GBPJPYm" || Symbol() == "GBPJPY" ) { MagicNo = 9130 * MagicBase; }
   if( Symbol() == "GBPUSDm" || Symbol() == "GBPUSD" ) { MagicNo = 9140 * MagicBase; }
   if( Symbol() == "NZDJPYm" || Symbol() == "NZDJPY" ) { MagicNo = 9150 * MagicBase; }
   if( Symbol() == "NZDUSDm" || Symbol() == "NZDUSD" ) { MagicNo = 9160 * MagicBase; }
   if( Symbol() == "USDCHFm" || Symbol() == "USDCHF" ) { MagicNo = 9170 * MagicBase; }
   if( Symbol() == "USDJPYm" || Symbol() == "USDJPY" ) { MagicNo = 9180 * MagicBase; }
   if( Symbol() == "USDCADm" || Symbol() == "USDCAD" ) { MagicNo = 9190 * MagicBase; }
   if( Symbol() == "XAUUSDm" || Symbol() == "XAUUSD" ) { MagicNo = 9200 * MagicBase; }
   if( Symbol() == "XAGUSDm" || Symbol() == "XAGUSD" ) { MagicNo = 9210 * MagicBase; }
   if( Symbol() == "GOLD"  ) { MagicNo = 92200 * MagicBase; }

   if( MagicNo == 0 ) { MagicNo = 9500 * MagicBase; }
   
   Spread=NormalizeDouble(MarketInfo(Symbol(),MODE_SPREAD),2);
   WorstSpread=Spread;
   
   Comment(CrLf+"EA is operational.\n",
          "On first tick this message will disapear.");
  
//----
   return(0);
  }
  
  
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   
   if (BarCount != Bars) NewBar();
   if (CurrentDayOfYear != DayOfYear()) NewDay();

   LoBuffer=(iCustom(NULL, 0, "5_34_5",0,0));
   TrendBuffer=(iCustom(NULL, 0, "5_34_5",1,0));

   Spread=NormalizeDouble(MarketInfo(Symbol(),MODE_SPREAD),2);
   if (Spread>WorstSpread) WorstSpread=Spread;
   
   UpDateOrderStatus();
 
   if (TrendBuffer > LoBuffer) 
      {
         LastTrend = 1;
         if (SellOpenOrders > 0) CloseSell(); 
      
         if (BuyOpenOrders < MaximumOpenTrades) 
         {
            if (PopUpAlert) Alert (VersionNumber + " Trend UP " + Symbol() + "  " + PeriodToString (Period()));
            Buy();
         }
      }

   if (TrendBuffer < LoBuffer) 
      {
         LastTrend = -1;
         if (BuyOpenOrders > 0) CloseBuy();
   
         if (SellOpenOrders < MaximumOpenTrades)
         {
            if (PopUpAlert) Alert (VersionNumber + " Trend DOWN " + Symbol() + "  " + PeriodToString (Period()));
            Sell();
         }
      }   
   
   ShowInfo();
   
//---- end of start routine
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment (" ");
//----
   return(0);
  }
  

  
//+------------------------------------------------------------------+


//
//
//
void NewBar()
{  // start of new bar routine
   BarCount = Bars;

   return(0);
}  // end of new bar routine

//
//
//
//
//
//
void NewDay()
{
   // start of new day routine
   CurrentDayOfYear=DayOfYear();
       
   WorstSpread=0;      

} // end of new day routine


      


//----------------------------------------------------------------------------------------
//       orders management
//----------------------------------------------------------------------------------------
//       buy and sell orders
//----------------------------------------------------------------------------------------
//
//
//
//
//

int Buy()
{ 
   int Ticket = -1, Error;
   RefreshRates();
   double aAsk = Ask;
   
   for(int cnt=1; cnt<=NumberOfTries; cnt++)
      { 
         Ticket  = OrderSend(Symbol(),OP_BUY,Lots,aAsk,Slippage,0,0," ",MagicNo,0,Blue);
         if (Ticket > 0)  break;
               
         Error = GetLastError(); 
         if (PopUpAlert) Alert ( "Buy Error Occured - Error: "+Error+" Try#: " +cnt+" "+ ErrorDescription(Error)+ " "+Symbol()+ " "+ PeriodToString (Period()));
         if(Error==129) RefreshRates(); //|| Error==136 || Error==137 || Error==138 || Error==146) //Busy errors
         Sleep (SleepTime);
      }
      
      if (Ticket <= 0) 
         {
            if (PopUpAlert)  Alert("Unable to Open Trade - "+ Symbol() + " " + PeriodToString (Period())); 
         } 

   return(Ticket);      
}

//
//
//
//
//

int Sell()
{ 
   int Ticket=-1, Error;
   RefreshRates();
   double aBid=Bid;
     
   for(int cnt=1; cnt<=NumberOfTries; cnt++)
      {  
         Ticket = OrderSend(Symbol(),OP_SELL,Lots,aBid,Slippage,0,0," ",MagicNo,0,Red);
         if (Ticket > 0) break;
         
         Error = GetLastError(); 
         if (PopUpAlert) Alert ( "Sell Error Occured - Error: "+Error+" Try#: " +cnt+" "+ ErrorDescription(Error)+ " "+Symbol()+ " "+ PeriodToString (Period()) );
         if(Error==129) RefreshRates(); ////if(Error==4 || Error==136 || Error==137 || Error==138 || Error==146) //Busy errors
         Sleep (SleepTime);
      }
      if (Ticket <= 0) 
         {
            if (PopUpAlert)  Alert("Unable to Open Trade - "+ Symbol() + " " + PeriodToString (Period())); 
         } 

   return(Ticket);  
}


//
//
//
//
//
int CloseBuy()
{ 
   int total = OrdersTotal();
   int cnt, Error=0;
   double cp;
   for(cnt=total-1;cnt>=0;cnt--)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol() && OrderType()== OP_BUY && OrderMagicNumber() == MagicNo) //  
            { 
               for(int c=1; c<=NumberOfTries; c++)
                  {
                     RefreshRates();
                     cp = Bid;
                     bool result=(OrderClose(OrderTicket(),OrderLots(),cp,Slippage,Yellow));
                     if (result) 
                        {
                           if (PopUpAlert)  Alert("Ticket Closed: " + OrderTicket()+ " "+Symbol()+ " "+ PeriodToString (Period()));  
                           break;
                        }
            
                     Error = GetLastError(); 
                     if (PopUpAlert) Alert ( "Close Buy Error Occured - Error: "+Error+" Try#: " +c+" "+ ErrorDescription(Error)+ " "+Symbol()+ " "+ PeriodToString (Period()) );
                           //if(Error==4 || Error==136 || Error==137 || Error==138 || Error==146) //Busy errors
              
                     Sleep (SleepTime);
                  }
               if (!result) 
                  {
                     if (PopUpAlert)  Alert("Unable to Close - Ticket: " + OrderTicket()+ " "+Symbol()+ " "+ PeriodToString (Period())); 
                  } 
            }
      } 
}


//
//
//
//
//
int CloseSell()
{ 
   int total = OrdersTotal();
   int cnt;
   double cp;
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderType()==OP_SELL && OrderMagicNumber() == MagicNo)  //   
      { 
         for(int c=1; c<=NumberOfTries; c++)
         {
            RefreshRates();
            cp = Ask;
            bool result = (OrderClose(OrderTicket(),OrderLots(),cp,Slippage,Yellow)); 
            if (result) 
               {
                  if (PopUpAlert)  Alert("Ticket Closed: " + OrderTicket()+ " "+Symbol()+ " "+ PeriodToString (Period()));  
                  break;
               }
            
            int Error = GetLastError(); 
            if (PopUpAlert) Alert ( "Close Sell Error Occured - Error: "+Error+" Try#: " +c+" "+ ErrorDescription(Error)+ " "+Symbol()+ " "+ PeriodToString (Period()) );
            //if(Error==4 || Error==136 || Error==137 || Error==138 || Error==146) //Busy errors
               
            Sleep(SleepTime); 
          }
          if (!result) 
            {
               if (PopUpAlert)  Alert("Unable to Close - Ticket: " + OrderTicket()+ " "+Symbol() + PeriodToString (Period()));   
            }
         }
   } 
}



//
//
//
//
//
//
int CloseAll()
{
   int total = OrdersTotal();
   int cnt;
   double cp;
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && (OrderType()==OP_BUY || OrderType()==OP_SELL) && OrderMagicNumber() == MagicNo)  //  
      { 
         for(int c=1; c<=NumberOfTries; c++)
         {
            if (PopUpAlert) Alert ( "Close All - Ticket: " +OrderTicket()+ "  Try#: " +c+ " "+Symbol() );
            RefreshRates();
            if (OrderType()==OP_BUY) {cp = Bid;} else {cp = Ask;}

            bool result = (OrderClose(OrderTicket(),OrderLots(),cp,Slippage,Yellow));
            if (result) 
               {
                  if (PopUpAlert)  Alert("Ticket Closed: " + OrderTicket()+ " "+Symbol());  
                  break;
               }

            int Error = GetLastError(); 
            if (PopUpAlert) Alert ( "Close All - Error Occured - Error: "+Error+" Try#: " +c+" "+ ErrorDescription(Error)+ " "+Symbol()+ " "+ PeriodToString (Period()) );
            //if(Error==4 || Error==136 || Error==137 || Error==138 || Error==146) //Busy errors
               Sleep(SleepTime); 
          }
        if (!result) 
            {
               if (PopUpAlert)  Alert("CloseAll Error - Ticket: " + OrderTicket()+ " "+Symbol()+ " "+ PeriodToString (Period()));   
            }
         
      }
   }
}


void UpDateOrderStatus()
{ // get order quanties
   ChartProfit=0;
   BuyOpenOrders=0;
   SellOpenOrders=0;

      for(int cnt=0; cnt<OrdersTotal(); cnt++)   
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         
	      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNo)
	      {
	        if (OrderType()== OP_BUY)
	          {				
	  	        BuyOpenOrders++;
	  	        ChartProfit=ChartProfit+OrderProfit();
	          }
	        if (OrderType()== OP_SELL)
	          {				
	  	        SellOpenOrders++;
	  	        ChartProfit=ChartProfit+OrderProfit();
	          }
	       }          
       }
} //  end UpDateOrderStatus
            
       


//
// Turn the graph period into a text string.
//
//
string PeriodToString(int iPeriod)
{
	switch (iPeriod)
	{
		case PERIOD_MN1: return("Monthly");
		case PERIOD_W1:  return("Weekly");
		case PERIOD_D1:  return("Daily");
		case PERIOD_H4:  return("H4");
		case PERIOD_H1:  return("H1");
		case PERIOD_M30: return("M30");
		case PERIOD_M15: return("M15");
		case PERIOD_M5:  return("M5");
		case PERIOD_M1:  return("M1");
		default:		     return("UnknownPeriod");
	}
	return (0);
}

//----------------------------------------------------------------------------------------
//       Error Descriptions 
//----------------------------------------------------------------------------------------
//
string ErrorDescription(int iError) 
{
   switch (iError)
   {
      case 0: return("unknown error");
      case 1: return("no error");
      case 2: return("common error");
      case 3: return("invalid trade parameters");
      case 4: return("trade server is busy");
      case 5: return("old version of the client terminal");
      case 6: return("no connection with trade server");
      case 7: return("not enough rights");
      case 8: return("too frequent requests");
      case 9: return("malfunctional trade operation");
      case 64: return("account disabled");
      case 65: return("invalid account");
      case 128: return("trade timeout");
      case 129: return("invalid price");
      case 130: return("invalid stops");
      case 131: return("invalid trade volume");
      case 132: return("market is closed");
      case 133: return("trade is disabled");
      case 134: return("not enough money");
      case 135: return("price changed");
      case 136: return("off quotes");
      case 137: return("broker is busy");
      case 138: return("requote");
      case 139: return("order is locked");
      case 140: return("long positions only allowed");
      case 141: return("too many requests");
      case 145: return("modification denied because order too close to market");
      case 146: return("trade context is busy");
      case 4000: return("no error");
      case 4001: return("wrong function pointer");
      case 4002: return("array index is out of range");
      case 4003: return("no memory for function call stack");
      case 4004: return("recursive stack overflow");
      case 4005: return("not enough stack for parameter");
      case 4006: return("no memory for parameter string");
      case 4007: return("no memory for temp string");
      case 4008: return("not initialized string");
      case 4009: return("not initialized string in array");
      case 4010: return("no memory for array\' string");
      case 4011: return("too long string");
      case 4012: return("remainder from zero divide");
      case 4013: return("zero divide");
      case 4014: return("unknown command");
      case 4015: return("wrong jump (never generated error)");
      case 4016: return("not initialized array");
      case 4017: return("dll calls are not allowed");
      case 4018: return("cannot load library");
      case 4019: return("cannot call function");
      case 4020: return("expert function calls are not allowed");
      case 4021: return("not enough memory for temp string returned from function");
      case 4022: return("system is busy (never generated error)");
      case 4050: return("invalid function parameters count");
      case 4051: return("invalid function parameter value");
      case 4052: return("string function internal error");
      case 4053: return("some array error");
      case 4054: return("incorrect series array using");
      case 4055: return("custom indicator error");
      case 4056: return("arrays are incompatible");
      case 4057: return("global variables processing error");
      case 4058: return("global variable not found");
      case 4059: return("function is not allowed in testing mode");
      case 4060: return("function is not confirmed");
      case 4061: return("send mail error");
      case 4062: return("string parameter expected");
      case 4063: return("integer parameter expected");
      case 4064: return("double parameter expected");
      case 4065: return("array as parameter expected");
      case 4066: return("requested history data in update state");
      case 4099: return("end of file");
      case 4100: return("some file error");
      case 4101: return("wrong file name");
      case 4102: return("too many opened files");
      case 4103: return("cannot open file");
      case 4104: return("incompatible access to a file");
      case 4105: return("no order selected");
      case 4106: return("unknown symbol");
      case 4107: return("invalid price parameter for trade function");
      case 4108: return("invalid ticket");
      case 4109: return("trade is not allowed");
      case 4110: return("longs are not allowed");
      case 4111: return("shorts are not allowed");
      case 4200: return("object already exist");
      case 4201: return("unknown object property");
      case 4202: return("object does not exist");
      case 4203: return("unknown object type");
      case 4204: return("no object name");
      case 4205: return("object coordinates error");
      case 4206: return("no specified subwindow");
      default: return("unknown error");
   }
   return ("unknown error");
}

//+-----------------------------------------------------+
//|           show summary panel on chart               |
//+-----------------------------------------------------+
void ShowInfo()
{             
   switch(TickRotate)
  {
   case 0:  TickDisplay=" . "; TickRotate = TickRotate + 1; break;
   case 1:  TickDisplay=" .. "; TickRotate = TickRotate + 1; break;
   case 2:  TickDisplay=" ... "; TickRotate = TickRotate + 1; break;
   case 3:  TickDisplay=" .... "; TickRotate = TickRotate + 1; break;
   case 4:  TickDisplay=" ..... "; TickRotate = TickRotate + 1; break;
   case 5:  TickDisplay=" ...... "; TickRotate = TickRotate + 1; break;
   case 6:  TickDisplay=" ....... "; TickRotate = TickRotate + 1; break;
   case 7:  TickDisplay=" ........ "; TickRotate = TickRotate + 1; break;
   case 8:  TickDisplay=" ......... "; TickRotate = TickRotate + 1; break;
   case 9:  TickDisplay=" .......... "; TickRotate = 0; break;
  }

   _text1="---";
   if (LastTrend>0)  _text1 = "UP";
   if (LastTrend<0)  _text1 = "DOWN";
   
   _text2=" ** Trading Allowed **";
   
   UpDateOrderStatus();

   DisplayText =CrLf+"...::: "+VersionNumber+" :::..."+ _text2+CrLf;
   
   DisplayText = DisplayText +"Date: "+Month()+"-"+Day()+"-"+Year()+" Server Time: "+Hour()+":"+Minute()+":"+Seconds()+TickDisplay+CrLf;       
   DisplayText = DisplayText +"Pair: "+ Symbol()+ " Price:  "+DoubleToStr(NormalizeDouble(Bid,4),4)+" Lot Size: "+DoubleToStr(Lots,2)+" MagicNo: "+MagicNo +CrLf; 
   DisplayText = DisplayText +"Actual Spread: "+DoubleToStr(Spread,2)+"  Worst Spread: "+DoubleToStr(WorstSpread,2)+" ChartProfit: "+DoubleToStr(ChartProfit,2)+CrLf;
   DisplayText = DisplayText +"LoBuffer: "+LoBuffer+" TrendBuffer "+TrendBuffer + CrLf;

   DisplayText = DisplayText +"Open Buy Orders: "+ BuyOpenOrders+ "  Open Sell Orders: "+ SellOpenOrders+"  Trend: "+ _text1+CrLf;
          
   Comment(DisplayText);      
          
  return(0);
}


